/*
CC -o mutex mutex.cc -L. -R. -g -lpthread -lposix4 -lthread_extensions
*/


#define _POSIX_C_SOURCE 199506L
#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <stdio.h>
#include <pthread.h>
#include <time.h>
#include "thread_extensions.h"


int global = 0;
pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;


class Mutex
{
pthread_mutex_t *mutex;

public:
Mutex(pthread_mutex_t *m);
virtual ~Mutex();
};


// Mutex constructor
Mutex::Mutex(pthread_mutex_t *m)
{
  mutex = m;
  pthread_mutex_lock(mutex);
}

// Mutex destructor
Mutex::~Mutex()
{
  pthread_mutex_unlock(mutex);
}

/* sleep time will be quantized at 10ms, CPU time is VERY approximate. */
void delay(int sleep_ms, int cpu_us)
{int i;
 struct timespec tv;

 if (sleep_ms == 0 && cpu_us == 0) return;
 tv.tv_sec = sleep_ms/1000;
 tv.tv_nsec = (sleep_ms%1000) * 1000000;
 nanosleep(&tv, NULL);

 for (i=0; i<cpu_us*10; i++) ;
}

void bar(void)
{Mutex m(&mutex);
 int temp;

 temp = global;
 delay(10, 0);
 printf("T@%d %d == %d\n", pthread_self(), temp, global);
 global = temp+1;

 /* Now the destructor gets called to unlock the mutex */
}

void *foo(void *arg)
{int i;

 for (i=0; i< 10; i++)
   {bar();
  }
 return(NULL);
}

main()
{int i;
 pthread_attr_t attr;
 pthread_t tid;

 pthread_attr_init(&attr);
 pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
 pthread_attr_setscope(&attr, PTHREAD_SCOPE_SYSTEM);

 for (i=0; i<4; i++)
   pthread_create(&tid, &attr, foo, NULL);
 pthread_exit(NULL);
}
